// GetCurrentProcess: http://msdn.microsoft.com/en-us/library/windows/desktop/ms683179%28v=vs.85%29.aspx
// GetProcessTimes: http://msdn.microsoft.com/en-us/library/windows/desktop/ms683223%28v=vs.85%29.aspx
// FileTimeToLocalFileTime: http://msdn.microsoft.com/en-us/library/windows/desktop/ms724277%28v=vs.85%29.aspx
// FileTimeToSystemTime: http://msdn.microsoft.com/en-us/library/windows/desktop/ms724280%28v=vs.85%29.aspx
// SystemTimeStructure: http://msdn.microsoft.com/en-us/library/windows/desktop/ms724950%28v=vs.85%29.aspx

#import "kernel32.dll"
   int GetCurrentProcess();
   bool GetProcessTimes(int hProcess, int& lpCreationTime[], int& lpExitTime[], int& lpKernelTime[], int& lpUserTime[]);
   bool FileTimeToLocalFileTime(int& lpFileTime[], int& lpLocalFileTime[]);
   bool FileTimeToSystemTime(int& lpFileTime[], int& lpSystemTime[]);
#import

int start() {
   datetime startTime = getProcessStartTime();
   if (startTime > 0) {
      Print("Process start time: " + TimeToStr(startTime, TIME_DATE) + " " + TimeToStr(startTime, TIME_SECONDS));
   } else {
      Print("Process start time is unknown.");
   }
   return(0);
}

datetime getProcessStartTime() {
   datetime startTime = 0;
   int creationTime[2], exitTime[2], kernelTime[2], userTime[2];
   int creationTimeLocal[2];
   int creationSystemTime[4];

   int currentProcessPseudoHandle = GetCurrentProcess();   
   bool isSuccess = GetProcessTimes(currentProcessPseudoHandle, creationTime, exitTime, kernelTime, userTime);
   if (isSuccess) {
   
      bool isLocalTimeConversionSuccess = FileTimeToLocalFileTime(creationTime, creationTimeLocal);
      if (isLocalTimeConversionSuccess) {
      
         bool isSystemTimeConversionSuccess = FileTimeToSystemTime(creationTimeLocal, creationSystemTime);
         if (isSystemTimeConversionSuccess) {
         
            int year = creationSystemTime[0] & 65535;
            int month = (creationSystemTime[0] >> 16) & 65535;
            int dayOfMonth = (creationSystemTime[1] >> 16) & 65535;
            int hour = creationSystemTime[2] & 65535;
            int minute = (creationSystemTime[2] >> 16) & 65535;
            int second = creationSystemTime[3] & 65535;
            
            startTime = StrToTime(year + "." + month + "." + dayOfMonth + " " + hour + ":" + minute);
            if (startTime > 0)
               startTime += second;
         
         } else {
            Print("SystemTimeConversion failed.");
         }
      } else {
         Print("LocalTimeConversion failed.");
      }
   } else {
      Print("GetProcessTimes failed.");
   }
   return(startTime);
}

